#ifndef TUNNELS_PLAYER_HPP
#define TUNNELS_PLAYER_HPP

#include "utils/player.hpp"
#include "utils/player_input.hpp"
#include <godot_cpp/classes/camera3d.hpp>
#include <godot_cpp/classes/character_body3d.hpp>
#include <godot_cpp/classes/input_event.hpp>

namespace godot {
class TunnelsPlayer : public CharacterBody3D, public IPlayer {
    GDCLASS(TunnelsPlayer, CharacterBody3D);
    static void _bind_methods();

public:
    virtual void _ready() override;
    virtual void _physics_process(double delta_time) override;

    virtual void setup_player_input(PlayerInput *input) override;
    virtual Node *to_node() override;

    void horizontal_move_input(Ref<InputEvent> event, float value);
    void vertical_move_input(Ref<InputEvent> event, float value);

    Vector3 get_world_move_input() const;
private:
    Vector2 move_input{0,0};

    Camera3D *camera{nullptr};
public:
    static float const MOVE_SPEED;
};
}

#endif // !TUNNELS_PLAYER_HPP
